workflow:
  rules:
    - if: $CI_MERGE_REQUEST_IID
    - if: $CI_COMMIT_TAG
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

default:
  image: alpine:latest

test:
  stage: test
  needs: []
  script:
    - echo "Success"

e2e:
  stage: test
  rules:
    - if: '$CI_MERGE_REQUEST_LABELS =~ /pipeline:mr-approved/'
  needs: []
  script:
    - sleep 30
    - echo "Success"
    - sleep 5

.update_status:
  stage: build
  script:
    - apk --update add jq curl
    - "echo CI_PROJECT_ID: $CI_PROJECT_ID"
    - "echo CI_MERGE_REQUEST_IID: $CI_MERGE_REQUEST_IID"
    - "echo CI_MERGE_REQUEST_SOURCE_BRANCH_SHA: $CI_MERGE_REQUEST_SOURCE_BRANCH_SHA"
    - echo "Setting pipeline as proper pipeline..."
    - >-
      curl --request POST --header "PRIVATE-TOKEN: $PROJECT_TOKEN"
      "https://gitlab.com/api/v4/projects/${CI_PROJECT_ID}/merge_requests/${CI_MERGE_REQUEST_IID}/status_check_responses"
      -d "sha=${CI_MERGE_REQUEST_SOURCE_BRANCH_SHA}"
      -d "external_status_check_id=1004571"
      -d "status=$STATUS" | jq

# This job is to mimic a full pipeline
full_pipeline:
  extends:
    - .update_status
  rules:
    - if: '$CI_MERGE_REQUEST_LABELS =~ /pipeline:mr-approved/'
  variables:
    STATUS: "passed"

# This job is to mimic a slim pipeline
slim_pipeline:
  extends:
    - .update_status
  rules:
    - if: '$CI_MERGE_REQUEST_LABELS !~ /pipeline:mr-approved/'
  variables:
    STATUS: "pending"
